package pay.platform.core.common.domain;

import cn.hutool.core.collection.CollectionUtil;
import com.mybatisflex.core.BaseMapper;
import com.mybatisflex.core.service.IService;
import com.mybatisflex.spring.service.impl.ServiceImpl;
import pay.platform.core.common.Result;
import lombok.extern.slf4j.Slf4j;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 基本服务
 *
 * @param <M>
 * @param <T>
 */
@Slf4j
public class BaseService<M extends BaseMapper<T>, T> extends ServiceImpl<M, T> implements IService<T> {

    /**
     * 删除
     *
     * @param ids ID集合
     * @return R<String>
     */
    @Transactional(rollbackFor = Exception.class)
    public Result<String> deleteByIds(List<String> ids) {
        if (CollectionUtil.isEmpty(ids)) {
            return Result.NG("删除失败");
        }
        boolean remove = removeByIds(ids);
        if (remove) {
            return Result.OK("删除成功");
        }
        return Result.NG("删除失败");
    }
}
