package pay.platform.domain;

import com.mybatisflex.annotation.Column;
import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.KeyType;
import com.mybatisflex.annotation.Table;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 商户管理 实体类。
 *
 * @author mybatis-flex-helper automatic generation
 * @since 1.0
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "商户管理")
@Table(value = "t_pay_merchant")
public class PayMerchant {

    /**
     * id
     */
    @Schema(description = "id")
    @Id(keyType = KeyType.Generator, value = "SUID")
    private String id;
    @Column(value = "agent_id")
    private String agentId;

    /**
     * 用户名
     */
    @Schema(description = "用户名")
    @Column(value = "user_name")
    private String userName;

    /**
     * 密码
     */
    @Schema(description = "密码")
    @Column(value = "password")
    private String password;

    /**
     * 余额
     */
    @Schema(description = "余额")
    @Column(value = "amount")
    private BigDecimal amount;

    /**
     * 费率
     */
    @Schema(description = "费率")
    @Column(value = "rate")
    private BigDecimal rate;

    /**
     * Google校验器
     */
    @Schema(description = "Google校验器")
    @Column(value = "tpop_code")
    private String tpopCode;

    /**
     * 是否绑定Google校验器
     */
    @Schema(description = "是否绑定Google校验器")
    @Column(value = "has_tpop")
    private String hasTpop;

    /**
     * 状态
     */
    @Schema(description = "状态 ")
    @Column(value = "status")
    private Integer status;

    /**
     * 创建人
     */
    @Schema(description = "创建人")
    @Column(value = "create_user")
    private String createUser;

    /**
     * 创建时间
     */
    @Schema(description = "创建时间")
    @Column(value = "create_time", onInsertValue = "now()")
    private LocalDateTime createTime;

    /**
     * 修改人
     */
    @Schema(description = "修改人")
    @Column(value = "update_user")
    private String updateUser;

    /**
     * 修改时间
     */
    @Schema(description = "修改时间")
    @Column(value = "update_time", onUpdateValue = "now()", onInsertValue = "now()")
    private LocalDateTime updateTime;
}
