package pay.platform.domain;

import com.mybatisflex.annotation.Column;
import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.KeyType;
import com.mybatisflex.annotation.Table;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.RequiredArgsConstructor;
import lombok.experimental.Accessors;

/**
 * 系统 - 用户表 实体类。
 *
 * @author admin
 * @since 1.0
 */
@Accessors(chain = true)
@RequiredArgsConstructor
@Data
@Schema(name = "系统 - 用户表")
@Table(value = "sys_user")
public class SysUser {

    /**
     * id
     */
    @Schema(description = "id")
    @Id(keyType = KeyType.Generator, value = "SUID")
    private String id;

    /**
     * 帐号
     */
    @Schema(description = "帐号")
    @Column(value = "username")
    private String username;

    /**
     * 密码
     */
    @Schema(description = "密码")
    @Column(value = "password")
    private String password;

    /**
     * 昵称
     */
    @Schema(description = "昵称")
    @Column(value = "nickname")
    private String nickname;

    /**
     * GoogleOTP
     */
    @Schema(description = "GoogleOTP")
    @Column(value = "otp")
    private String otp;

    /**
     * 是否启用
     */
    @Schema(description = "是否启用")
    @Column(value = "enable")
    private Integer enable;

    /**
     * 是否网点管理员
     */
    @Schema(description = "是否网点管理员")
    @Column(value = "is_manage")
    private Integer isManage;

    /**
     * 创建者
     */
    @Schema(description = "创建者")
    @Column(value = "create_user")
    private String createUser;

    /**
     * 创建时间
     */
    @Schema(description = "创建时间")
    @Column(value = "create_time", onInsertValue = "now()")
    private java.time.LocalDateTime createTime;

    /**
     * 更新者
     */
    @Schema(description = "更新者")
    @Column(value = "update_user")
    private String updateUser;

    /**
     * 更新时间
     */
    @Schema(description = "更新时间")
    @Column(value = "update_time", onUpdateValue = "now()", onInsertValue = "now()")
    private java.time.LocalDateTime updateTime;


}
