package pay.platform.mapper;

import com.mybatisflex.core.BaseMapper;
import pay.platform.domain.SysUserRole;
import pay.platform.domain.table.SysUserRoleTableDef;
import lombok.NonNull;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Set;

/**
 * 系统 - 用户角色 映射层。
 *
 * @author admin
 * @since 1.0
 */
@Mapper
public interface SysUserRoleMapper extends BaseMapper<SysUserRole> {

    /**
     * 保存用户角色
     *
     * @param userId  .
     * @param roleIds .
     * @return .
     */
    default int saveUserRole(@NonNull String userId, @NonNull Set<String> roleIds) {
        List<SysUserRole> list = roleIds.stream().map(roleId -> new SysUserRole(userId, roleId)).toList();
        return insertBatch(list);
    }

    /**
     * 根据用户ID删除用户角色
     *
     * @param userId .
     * @return .
     */
    default int delUserRoleByUserid(@NonNull String userId) {
        return deleteByCondition(SysUserRoleTableDef.SYS_USER_ROLE.USER_ID.eq(userId));
    }

    /**
     * 根据用户ID删除用户角色
     *
     * @param userIds .
     * @return .
     */
    default int delUserRoleByUserids(@NonNull List<String> userIds) {
        return deleteByCondition(SysUserRoleTableDef.SYS_USER_ROLE.USER_ID.in(userIds));
    }
}
