package pay.platform.payment.alipay.trade.utils;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.reflect.TypeToken;
import pay.platform.payment.alipay.trade.model.hb.*;
import pay.platform.payment.alipay.trade.model.hb.*;

import java.lang.reflect.Type;
import java.util.List;

/**
 * @author liuyangkly
 * date15/6/26
 * 使用google gson作为json序列化反序列化工具
 */
public class GsonFactory {

    private static class GsonHolder {
        private static Type exceptionListType = new TypeToken<List<ExceptionInfo>>() {
        }.getType();
        private static Type tradeInfoListType = new TypeToken<List<TradeInfo>>() {
        }.getType();

        private static Gson gson = new GsonBuilder()
                .registerTypeAdapter(exceptionListType, new ExceptionInfoAdapter())
                .registerTypeAdapter(tradeInfoListType, new TradeInfoAdapter())
                .registerTypeAdapter(EquipStatus.class, new EquipStatusAdapter())
                .create();
    }

    /**
     * Gets gson.
     *
     * @return the gson
     */
    public static Gson getGson() {
        return GsonHolder.gson;
    }
}
