package pay.platform.api.system.cache;

import pay.platform.domain.SysConfig;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;

import java.util.Optional;

/**
 * 配置缓存
 */
@Component
@RequiredArgsConstructor
public class ConfigCache implements CacheUtil {

    private final PlatformCache cache;

    /**
     * 设置缓存
     *
     * @param config .
     * @return .
     */
    public boolean putCache(SysConfig config) {
        String key = getCacheKey(DefaultKeyValue.SYS_CONFIG, config.getCode());
        return cache.set(key, config.getValue());
    }

    /**
     * 移除缓存
     *
     * @param code .
     * @return .
     */
    public boolean delCache(String code) {
        String key = getCacheKey(DefaultKeyValue.SYS_CONFIG, code);
        return cache.del(key);
    }

    /**
     * 获取缓存
     *
     * @param code .
     * @return .
     */
    public Optional<String> getCache(String code) {
        String key = getCacheKey(DefaultKeyValue.SYS_CONFIG, code);
        return cache.getStr(key);
    }
}
