package pay.platform.api.system.servcie.impl;


import cn.hutool.core.bean.BeanUtil;
import com.mybatisflex.core.paginate.Page;
import com.mybatisflex.core.query.QueryWrapper;
import com.mybatisflex.core.util.StringUtil;
import org.springframework.stereotype.Service;
import pay.platform.api.system.model.query.PayAgentQuery;
import pay.platform.api.system.model.vo.PayAgentVO;
import pay.platform.api.system.servcie.PayAgentService;
import pay.platform.core.common.domain.BasePage;
import pay.platform.core.common.domain.BaseService;
import pay.platform.core.util.PasswordUtil;
import pay.platform.domain.PayAgent;
import pay.platform.domain.table.PayAgentTableDef;
import pay.platform.mapper.PayAgentMapper;

import java.util.List;

import static pay.platform.domain.table.PayAgentTableDef.PAY_AGENT;

/**
 * 代理系统 服务层实现。
 *
 * @author mybatis-flex-helper automatic generation
 * @since 1.0
 */
@Service
public class PayAgentServiceImpl extends BaseService<PayAgentMapper, PayAgent> implements PayAgentService {

    @Override
    public boolean saveAgent(PayAgent payAgent) {
        payAgent.setPassword(PasswordUtil.encoder(payAgent.getPassword()));
        return save(payAgent);
    }

    @Override
    public BasePage<PayAgentVO> queryPage(PayAgentQuery query) {
        QueryWrapper queryWrapper = QueryWrapper.create().from(PayAgentTableDef.PAY_AGENT).where("1 = 1")
                .and(PayAgentTableDef.PAY_AGENT.USER_NAME.like(query.getUserName(), StringUtil.isNotBlank(query.getUserName())))
                .and(PAY_AGENT.STATUS.eq(query.getStatus(), query.getStatus() != null));
        Page<PayAgent> page = mapper.paginate(new Page<>(query.getCurrent(), query.getSize()), queryWrapper);
        List<PayAgentVO> vos = BeanUtil.copyToList(page.getRecords(), PayAgentVO.class);
        return new BasePage<>(page.getPageNumber(), page.getPageSize(), page.getTotalRow(), vos);
    }
}