package pay.platform.api.system.servcie.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.RandomUtil;
import com.mybatisflex.core.paginate.Page;
import com.mybatisflex.core.query.QueryWrapper;
import com.mybatisflex.core.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import pay.platform.api.system.model.query.PayMerchantQuery;
import pay.platform.api.system.model.vo.PayMerchantVO;
import pay.platform.api.system.servcie.PayMerchantAppKeyService;
import pay.platform.api.system.servcie.PayMerchantService;
import pay.platform.core.common.domain.BasePage;
import pay.platform.core.common.domain.BaseService;
import pay.platform.core.util.PasswordUtil;
import pay.platform.domain.PayMerchant;
import pay.platform.domain.PayMerchantAppKey;
import pay.platform.mapper.PayMerchantMapper;

import java.util.List;

import static pay.platform.domain.table.PayMerchantTableDef.PAY_MERCHANT;

/**
 * 商户管理 服务层实现。
 *
 * @author mybatis-flex-helper automatic generation
 * @since 1.0
 */
@Service
public class PayMerchantServiceImpl extends BaseService<PayMerchantMapper, PayMerchant> implements PayMerchantService {

    @Autowired
    private PayMerchantAppKeyService payMerchantAppKeyService;

    @Override
    @Transactional
    public boolean saveMerchant(PayMerchant payMerchant) {
        payMerchant.setPassword(PasswordUtil.encoder(payMerchant.getPassword()));
        save(payMerchant);

        PayMerchantAppKey payMerchantAppKey = PayMerchantAppKey.builder().appId(RandomUtil.randomString(18)).appSecret(RandomUtil.randomString(32))
                .appKey(RandomUtil.randomString(12))
                .merchantId(payMerchant.getId()).build();
        payMerchantAppKeyService.save(payMerchantAppKey);
        return true;
    }


    @Override
    public BasePage<PayMerchantVO> queryPage(PayMerchantQuery query) {
        QueryWrapper queryWrapper = QueryWrapper.create().from(PAY_MERCHANT).where("1 = 1")
                .and(PAY_MERCHANT.USER_NAME.like(query.getUserName(), StringUtil.isNotBlank(query.getUserName())))
                .and(PAY_MERCHANT.STATUS.eq(query.getStatus(), query.getStatus() != null));
        Page<PayMerchant> page = mapper.paginate(new Page<>(query.getCurrent(), query.getSize()), queryWrapper);
        List<PayMerchantVO> vos = BeanUtil.copyToList(page.getRecords(), PayMerchantVO.class);
        return new BasePage<>(page.getPageNumber(), page.getPageSize(), page.getTotalRow(), vos);
    }
}