package pay.platform.api.system.model.response;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import java.io.Serializable;
import java.util.List;

/**
 * Login 响应正文
 */
@Data
@EqualsAndHashCode
@ToString
public class LoginResponse implements Serializable {

    @Schema(description = "用户名")
    private String username;

    @Schema(description = "用户昵称")
    private String nickname;

    @Schema(description = "权限")
    private List<String> permissions;

    @Schema(description = "访问token")
    private String token;
}
