package pay.platform.api.system.servcie.impl;


import com.mybatisflex.core.query.QueryWrapper;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import pay.platform.api.system.servcie.PayAgentService;
import pay.platform.core.common.domain.BaseService;
import pay.platform.domain.PayAgent;
import pay.platform.domain.table.PayAgentTableDef;
import pay.platform.mapper.PayAgentMapper;

import java.util.Optional;

/**
 * 代理系统 服务层实现。
 *
 * @author mybatis-flex-helper automatic generation
 * @since 1.0
 */
@Service
public class PayAgentServiceImpl extends BaseService<PayAgentMapper, PayAgent> implements PayAgentService {

    /**
     * 根据用户名获取用户信息
     *
     * @param username 用户名
     * @return .
     */
    public Optional<PayAgent> loadUserByUsername(String username) {
        QueryWrapper queryWrapper = QueryWrapper.create().from(PayAgentTableDef.PAY_AGENT).where(PayAgentTableDef.PAY_AGENT.USER_NAME.eq(username));
        PayAgent sysUser = mapper.selectOneByQuery(queryWrapper);
        return Optional.ofNullable(sysUser);
    }

    /**
     * 是否有谷歌验证器
     *
     * @param id ID
     * @return true/false
     */
    public boolean hasGoogleOtp(String id) {
        PayAgent sysUser = getById(id);
        return StringUtils.hasText(sysUser.getTpopCode());
    }
}