package pay.platform.api.system.servcie.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.RandomUtil;
import com.mybatisflex.core.paginate.Page;
import com.mybatisflex.core.query.QueryWrapper;
import com.mybatisflex.core.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import pay.platform.api.system.model.query.PayChannelQuery;
import pay.platform.api.system.model.vo.PayChannelVO;
import pay.platform.api.system.servcie.PayAggregationStoreService;
import pay.platform.api.system.servcie.PayChannelService;
import pay.platform.core.common.domain.BasePage;
import pay.platform.core.common.domain.BaseService;
import pay.platform.core.security.util.SecurityUtil;
import pay.platform.domain.PayAggregationStore;
import pay.platform.domain.PayChannel;
import pay.platform.domain.table.PayChannelTableDef;
import pay.platform.mapper.PayChannelMapper;

import java.util.ArrayList;
import java.util.List;

/**
 * 通道管理 服务层实现。
 *
 * @author mybatis-flex-helper automatic generation
 * @since 1.0
 */
@Service
public class PayChannelServiceImpl extends BaseService<PayChannelMapper, PayChannel> implements PayChannelService {

    @Autowired
    private PayAggregationStoreService payAggregationStoreService;

    @Override
    @Transactional
    public boolean savePayChannel(PayChannel payChannel) {
        payChannel.setAgentId(SecurityUtil.getCurrentUser().getUserid());
        save(payChannel);
        List<PayAggregationStore> storeList = new ArrayList<>();
        for (int i = 0; i < 7; i++) {
            PayAggregationStore PayAggregationStore = new PayAggregationStore();
            PayAggregationStore.setChannelId(payChannel.getId());
            PayAggregationStore.setStoreId(RandomUtil.randomNumbers(13));
            PayAggregationStore.setOperatorId(RandomUtil.randomNumbers(6));
            storeList.add(PayAggregationStore);

        }
        payAggregationStoreService.saveBatch(storeList);
        return false;
    }

    @Override
    public BasePage<PayChannelVO> queryPage(PayChannelQuery query) {
        QueryWrapper queryWrapper = QueryWrapper.create().from(PayChannelTableDef.PAY_CHANNEL).where("1 = 1")
                .and(PayChannelTableDef.PAY_CHANNEL.NAME.like(query.getName(), StringUtil.isNotBlank(query.getName())))
                .and(PayChannelTableDef.PAY_CHANNEL.STATUS.eq(query.getStatus(), query.getStatus() != null))
                .and(PayChannelTableDef.PAY_CHANNEL.AGENT_ID.eq(SecurityUtil.getCurrentUser().getUserid(), StringUtil.isNotBlank(SecurityUtil.getCurrentUser().getUserid())));
        Page<PayChannel> page = mapper.paginate(new Page<>(query.getCurrent(), query.getSize()), queryWrapper);
        List<PayChannelVO> vos = BeanUtil.copyToList(page.getRecords(), PayChannelVO.class);
        return new BasePage<>(page.getPageNumber(), page.getPageSize(), page.getTotalRow(), vos);
    }
}