package pay.platform.api.system.model.vo;

import com.mybatisflex.annotation.Table;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 聚合支付 实体类。
 *
 * @author mybatis-flex-helper automatic generation
 * @since 1.0
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Schema(name = "聚合支付")
@Table(value = "t_pay_aggregation")
public class PayAggregationVO {

    /**
     * id
     */
    @Schema(description = "id")
    private Long id;

    /**
     * 通道ID
     */
    @Schema(description = "通道ID")
    private String channelId;

    /**
     * 商户号名称
     */
    @Schema(description = "商户号名称")
    private String name;

    /**
     * 商户号ID
     */
    @Schema(description = "商户号ID")
    private Long pId;

    /**
     * 密钥
     */
    @Schema(description = "密钥")
    private String privateKey;

    /**
     * 公钥
     */
    @Schema(description = "公钥")
    private String publicKey;

    /**
     * 单笔限制金额
     */
    @Schema(description = "单笔限制金额")
    private BigDecimal astrictAmount;

    /**
     * 限制流水
     */
    @Schema(description = "限制流水")
    private BigDecimal astrictTrade;

    /**
     * 统一费率
     */
    @Schema(description = "统一费率")
    private BigDecimal rate;

    /**
     * 状态
     */
    @Schema(description = "状态 ")
    private Integer status;


    /**
     * 创建人
     */
    @Schema(description = "创建人")
    private String createUser;

    /**
     * 创建时间
     */
    @Schema(description = "创建时间")
    private LocalDateTime createTime;

    /**
     * 修改人
     */
    @Schema(description = "修改人")
    private String updateUser;

    /**
     * 修改时间
     */
    @Schema(description = "修改时间")
    private LocalDateTime updateTime;
}
