package pay.platform.api.system.servcie.impl;


import com.mybatisflex.core.query.QueryWrapper;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import pay.platform.api.system.servcie.PayMerchantService;
import pay.platform.core.common.domain.BaseService;
import pay.platform.domain.PayMerchant;
import pay.platform.domain.table.PayAgentTableDef;
import pay.platform.domain.table.PayMerchantTableDef;
import pay.platform.mapper.PayMerchantMapper;

import java.util.Optional;

/**
 * 商户管理 服务层实现。
 *
 * @author mybatis-flex-helper automatic generation
 * @since 1.0
 */
@Service
public class PayMerchantServiceImpl extends BaseService<PayMerchantMapper, PayMerchant> implements PayMerchantService {

    /**
     * 根据用户名获取用户信息
     *
     * @param username 用户名
     * @return .
     */
    public Optional<PayMerchant> loadUserByUsername(String username) {
        QueryWrapper queryWrapper = QueryWrapper.create().from(PayMerchantTableDef.PAY_MERCHANT).where(PayAgentTableDef.PAY_AGENT.USER_NAME.eq(username));
        PayMerchant sysUser = mapper.selectOneByQuery(queryWrapper);
        return Optional.ofNullable(sysUser);
    }

    /**
     * 是否有谷歌验证器
     *
     * @param id ID
     * @return true/false
     */
    public boolean hasGoogleOtp(String id) {
        PayMerchant sysUser = getById(id);
        return StringUtils.hasText(sysUser.getTpopCode());
    }
}