package pay.platform.core.exception;

import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import pay.platform.core.common.Result;

/**
 * 定义全局异常处理
 **/
@RestControllerAdvice
@Slf4j
public class GlobalControllerExceptionHandler {
    @ExceptionHandler(value = {BusinessException.class})
    @ResponseStatus(HttpStatus.OK)
    public Result businessException(BusinessException ex) {
        log.error(ex.getMessage(), ex);
        return Result.error(500, ex.getMessage());
    }

    @ExceptionHandler(value = {Exception.class})
    @ResponseStatus(HttpStatus.OK)
    public Result unknownException(Exception ex) {
        log.error(ex.getMessage(), ex);
        return Result.error(500, ex.getMessage());
    }
}
